## mknbi 1.4.4

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
-VERSION=1.4.3
+VERSION=1.4.4
 EXTRAVERSION=
-TARVERSION=1.4.3
+TARVERSION=1.4.4
 # spec file can override
 RPMVERSION=$(VERSION)
 
@@ -44,7 +44,7 @@
 INSTLIBDIR=	$(INSTPREFIX)/lib/mknbi
 BINDIR=		$(INSTPREFIX)/bin
 MANDIR=		$(INSTPREFIX)/share/man/man1
-DOCDIR=		$(INSTPREFIX)/share/doc/mknbi-$(RPMVERSION)
+DOCDIR=		$(INSTPREFIX)/share/doc/packages/mknbi-$(RPMVERSION)
 
 INSTALL=	install
 
@@ -87,18 +87,18 @@
 	chmod 755 nbitoelf
 
 # 32-bit first stage protected mode call setup program
-first32@%.linux:	start32@%.o first32.o memsizes.o printf.o
-	$(LD) -N -Ttext $* -e _start $(LDBINARYFLAG) -o $@ start32@$*.o first32.o memsizes.o printf.o
+first32@%.linux:	start32@%.o first32.o memsizes.o printf.o string.o
+	$(LD) -N -Ttext $* -e _start $(LDBINARYFLAG) -o $@ start32@$*.o first32.o memsizes.o printf.o string.o
 	@if [ `wc -c < $@` -gt $(FIRST32SIZE) ]; then echo Binary too large; fi
 
 # 32-bit first stage ELF setup program
-first32elf@%.linux:	start32@%.o first32elf.o memsizes.o printf.o
-	$(LD) -N -Ttext $* -e _start $(LDBINARYFLAG) -o $@ start32@$*.o first32elf.o memsizes.o printf.o
+first32elf@%.linux:	start32@%.o first32elf.o memsizes.o printf.o string.o
+	$(LD) -N -Ttext $* -e _start $(LDBINARYFLAG) -o $@ start32@$*.o first32elf.o memsizes.o printf.o string.o
 	@if [ `wc -c < $@` -gt $(FIRST32SIZE) ]; then echo Binary too large; fi
 
 # 32-bit first stage ELF DOS setup program
-first32elf@%.dos:	start32@%.o first32dos.o printf.o
-	$(LD) -N -Ttext $* -e _start $(LDBINARYFLAG) -o $@ start32@$*.o first32dos.o printf.o
+first32elf@%.dos:	start32@%.o first32dos.o printf.o string.o
+	$(LD) -N -Ttext $* -e _start $(LDBINARYFLAG) -o $@ start32@$*.o first32dos.o printf.o string.o
 
 start32@%.o:	start32.S
 	gcc -E -DRELOC=$* $(OLDGAS) start32.S | $(AS) -o start32@$*.o
@@ -243,12 +243,12 @@
 	-mkdir -p $(MANDIR)
 	$(INSTALL) -m 644 mknbi.1 disnbi.1 $(MANDIR)/
 	cd $(MANDIR); \
-	for i in mkelf mknbi-linux mkelf-linux mknbi-rom mkelf-img mknbi-menu mkelf-menu mknbi-nfl mkelf-nfl mkelf-lua mknbi-dos mknbi-fdos; \
+	for i in mkelf mknbi-linux mkelf-linux mknbi-rom mkelf-img mknbi-menu mkelf-menu mknbi-nfl mkelf-nfl mknbi-dos mknbi-fdos mkelf-lua; \
 	do \
 		ln -sf mknbi.1 $$i.1; \
 	done
 	-mkdir -p $(DOCDIR)
-	$(INSTALL) -m 644 README LOG spec.txt $(DOCDIR)/
+	$(INSTALL) -m 644 COPYING README LOG spec.txt $(DOCDIR)/
 
 tarball:
 	mkdir -p luabuild
