=== debian/changelog ===
mknbi (1.4.4-14) unstable; urgency=medium

  * QA upload.
  * Clean up leftover diversions dating back to lenny.  (Closes: #861259)

 -- Andreas Beckmann <anbe@debian.org>  Wed, 26 Apr 2017 18:18:17 +0200

mknbi (1.4.4-13) unstable; urgency=medium

  * QA upload.
  * Add patch from Steve Beattie to fix PIE FTBFS. (Closes: #852851)

 -- Adrian Bunk <bunk@debian.org>  Sat, 28 Jan 2017 00:23:07 +0200

mknbi (1.4.4-12) unstable; urgency=medium

  * QA upload.
  * debian/control: added Vcs-Browser, Vcs-Git.
  * fix a misspelled override_dh_installchangelogs in debian/rules. Thanks
    to  Chris Lamb for the patch (closes: #831776).
  * patch 06-reproducible-builds.patch: make the build reproducible. Thanks
    to Chris Lamb for the patch (closes: #831432).
  * normalise name of 05-gcc-5.patch

 -- Ralf Treinen <treinen@debian.org>  Wed, 03 Aug 2016 14:40:44 +0200

mknbi (1.4.4-11) unstable; urgency=medium

  * QA upload.
  * Fix "ftbfs with GCC-5": add patch from Matthias Klose/Ubuntu:
    Build with -fgnu89-inline for GCC 5.
    (Closes: #778009)

 -- gregor herrmann <gregoa@debian.org>  Sat, 18 Jul 2015 20:55:44 +0200

mknbi (1.4.4-10) unstable; urgency=low

  * QA upload.
  * Makefile: Add -fno-stack-protector to CFLAGS (thanks, Michael Bienia;
    LP: #520648).

 -- Colin Watson <cjwatson@debian.org>  Tue, 07 May 2013 17:53:26 +0100

mknbi (1.4.4-9) unstable; urgency=low

  * Updating to debhelper version 8.
  * Updating to standards version 3.9.2.
  * Switching to source format 3.0 (quilt).
  * Compacting copyright file.
  * Orphaning package.

 -- Daniel Baumann <daniel@debian.org>  Thu, 08 Sep 2011 07:23:39 +0000

mknbi (1.4.4-8) experimental; urgency=low

  * Updating build-depends and architecture for kbfreebsd, thanks to
    Petr Salinger <Petr.Salinger@seznam.cz> (Closes: #597049).

 -- Daniel Baumann <daniel@debian.org>  Thu, 16 Sep 2010 09:47:35 +0200

mknbi (1.4.4-7) unstable; urgency=low

  * Adding patch from Colin Watson <cjwatson@ubuntu.com> to pass
    appropriate options to ld and as to make multilib build work
    (Closes: #593609).
  * Updating standards version to 3.9.1.

 -- Daniel Baumann <daniel@debian.org>  Wed, 01 Sep 2010 10:19:19 +0200

mknbi (1.4.4-6) unstable; urgency=low

  * Updating standards version to 3.9.0.
  * Building with gcc-multilib (Closes: #587734).

 -- Daniel Baumann <daniel@debian.org>  Thu, 01 Jul 2010 14:53:45 +0200

mknbi (1.4.4-5) unstable; urgency=low

  * Correcting yet another spelling error in package long-description
    (Closes: #584708).

 -- Daniel Baumann <daniel@debian.org>  Sun, 06 Jun 2010 09:35:07 +0200

mknbi (1.4.4-4) unstable; urgency=low

  * Correcting another spelling error in package long-description
    (Closes: #584618).

 -- Daniel Baumann <daniel@debian.org>  Sat, 05 Jun 2010 08:32:16 +0200

mknbi (1.4.4-3) unstable; urgency=low

  * Updating year in copyright file.
  * Updating to standards 3.8.4.
  * Correcting spelling error in package long-description (Closes:
    #584131).

 -- Daniel Baumann <daniel@debian.org>  Fri, 04 Jun 2010 17:30:33 +0200

mknbi (1.4.4-2) unstable; urgency=low

  * New maintainer, taking over package from Gergely with thanks for all his
    past work on it.
  * Redone debian packaging from scratch, including:
    - adding amd64 into architecture list (Closes: #427478).
    - adding kfreebsd-amd64 and kfreebsd-i386 into architecture list
      (Closes: #366409).

 -- Daniel Baumann <daniel@debian.org>  Wed, 16 Dec 2009 13:51:06 +0100

mknbi (1.4.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix bashism in debian/rules (Closes: #478407)
  * debian/control:
    - Bump Standards-Version to 3.8.0.
    - Move upstream URL to Homepage: field

 -- Chris Lamb <chris@chris-lamb.co.uk>  Sat, 07 Jun 2008 22:38:23 +0100

mknbi (1.4.4-1) unstable; urgency=low

  * New upstream release (closes: #323733, #329453)
  * Improvements from Erik Schanze (closes: #329452)

 -- RISKO Gergely <risko@debian.org>  Thu, 17 Nov 2005 20:41:04 +0100

mknbi (1.4.3-2) unstable; urgency=low

  * fix version string bugs (probably forever with help of Mark Williams
    (closes: #255139)
  * better copyright file written and included

 -- RISKO Gergely <risko@debian.org>  Fri, 13 Aug 2004 16:24:20 +0200

mknbi (1.4.3-1) unstable; urgency=low

  * New upstream release

 -- RISKO Gergely <risko@debian.org>  Thu, 20 May 2004 17:11:26 +0200

mknbi (1.4.0-1) unstable; urgency=low

  * New upstream release (closes: #201304)

 -- RISKO Gergely <risko@debian.org>  Tue, 15 Jul 2003 11:33:47 +0200

mknbi (1.2.12-2) unstable; urgency=low

  * fix version in debian/rules

 -- RISKO Gergely <risko@debian.org>  Wed, 26 Mar 2003 22:37:36 +0100

mknbi (1.2.12-1) unstable; urgency=low

  * New upstream release (closes: #171764)

 -- RISKO Gergely <risko@debian.org>  Fri, 17 Jan 2003 15:42:52 +0100

mknbi (1.2.7-2) unstable; urgency=low

  * fix version string in dosnbi (closes: Bug#144498)

 -- RISKO Gergely <risko@debian.org>  Sun,  5 May 2002 16:25:03 +0200

mknbi (1.2.7-1) unstable; urgency=low

  * new upstream (closes: Bug#140284)

 -- RISKO Gergely <risko@debian.org>  Thu, 28 Mar 2002 14:05:26 +0100

mknbi (1.2-4) unstable; urgency=low

  * changed the totally bad description. (closes: Bug#133983)

 -- RISKO Gergely <risko@debian.org>  Fri, 15 Feb 2002 18:45:01 +0100

mknbi (1.2-3) unstable; urgency=high

  * fixed a very nasty bug (files missing from /usr/lib/mknbi)

 -- RISKO Gergely <risko@debian.org>  Thu, 27 Dec 2001 10:47:57 +0100

mknbi (1.2-2) unstable; urgency=low

  * divert the old netboot files (closes: Bug#122403)

 -- RISKO Gergely <risko@debian.org>  Sun, 16 Dec 2001 14:31:22 +0100

mknbi (1.2-1) unstable; urgency=low

  * Initial Release. (closes: Bug#119553)

 -- RISKO Gergely <risko@debian.org>  Wed, 14 Nov 2001 19:02:41 +0100
