=== debian/control ===
Source: mknbi
Section: admin
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper (>= 8), gcc-multilib [any-amd64], nasm, perl
Standards-Version: 3.9.2
Homepage: http://www.etherboot.org/
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/mknbi.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/mknbi.git

Package: mknbi
Depends: ${misc:Depends}, perl
Architecture: any-amd64 any-i386
Description: Create tagged images for Etherboot or Netboot
 With mknbi you can create tagged images for Etherboot. Tagged images are data
 files, which contain the necessary files for booting up (kernel+root for
 Linux, kernel+minifs for DOS, ...) bundled together with a special format.
 .
 These tagged images are downloaded and understood by Etherboot and Netboot
 during the boot process.
 .
 This package should be used on the server and not on the client. It doesn't
 contain code which handles the network card, downloads the image, etc.
