=== debian/rules ===
#!/usr/bin/make -f

export FIRSTRELOCS=0x82800 0x92800

%:
	dh ${@}

override_dh_auto_clean:
	rm -f nfl menu
	rm -f first32\@0x82800.linux
	rm -f first32\@0x82800.linux
	rm -f first32elf\@0x92800.linux
	rm -f first32elf\@0x92800.linux

	$(MAKE) clean

override_dh_auto_build:
	$(MAKE) PREFIX=/usr

override_dh_auto_install:
	mkdir -p debian/mknbi/usr/lib/mknbi

	cp mknbi debian/mknbi/usr/lib/mknbi/mknbi
	cp disnbi.pl debian/mknbi/usr/lib/mknbi/disnbi
	cp dismbr.pl debian/mknbi/usr/lib/mknbi/dismbr
	cp disdosbb.pl debian/mknbi/usr/lib/mknbi/disdosbb

	cp Nbi.pm Elf.pm TruncFD.pm \
	$(foreach i,$(FIRSTRELOCS),first32@$(i).linux first32elf@$(i).linux) \
	first.dos first.fdos menu debian/mknbi/usr/lib/mknbi

override_dh_installchangelogs:
	dh_installchangelogs LOG

override_dh_fixperms:
	dh_fixperms

	chmod 0644 debian/mknbi/usr/lib/mknbi/*.linux
	chmod 0644 debian/mknbi/usr/lib/mknbi/*.pm
	chmod 0644 debian/mknbi/usr/lib/mknbi/menu
